import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;

/**
 * Write a description of class LifeBonus here.
 * 
 * @author Ofir Sela
 * @version 1.0.0
 */
public class Bonus extends Actor
{
    private int type;
    private GreenfootImage[] image = new GreenfootImage[4];
    
    private static final int bonusTime = 700; // For how long does the bonus stay in the world
    private int timeCount = 0; // How long ago we created the bonus
    
    /**
     * Create a bonus and set its type randomly.
     */
    public Bonus()
    {
       type = Greenfoot.getRandomNumber(3)+1;
       image[1] = new GreenfootImage("lifeBonus.png");
       image[2] = new GreenfootImage("shieldBonus.png");
       image[3] = new GreenfootImage("scoreBonus.png");
       setImage(image[type]);
    }
    /**
     * Create a bonus and set its type by a given integer (1 = life, 2 = shield, 3 = score).
     */
    public Bonus(int kind)
    {
       type = kind;
       image[1] = new GreenfootImage("lifeBonus.png");
       image[2] = new GreenfootImage("shieldBonus.png");
       image[3] = new GreenfootImage("scoreBonus.png");
       setImage(image[type]);
    }

    /**
     * Act - do whatever the LifeBonus wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
       check();
    }
    
    /**
     * If the time sience we created the bonus is equal to bonusTime - remove this bonus from the world.
     * If the rocket collides with a bonus, give him the bonus.
     */
    public void check()
    {
       int range = getImage().getWidth()/2;
       List<Rocket> collision = getObjectsInRange(range, Rocket.class);
       if(collision.size() != 0) {
          for( Rocket a : collision) {
             if(type == 1) ((Space) getWorld()).addLives(1);
             else if(type == 2) a.setShield(true);
             else if(type == 3) ((Space) getWorld()).countScore(10);
             getWorld().removeObject(this);
          }
       }
       else if(timeCount == bonusTime) getWorld().removeObject(this);
       else timeCount++;
    }
}
