import greenfoot.*;  // (World, Actor, GreenfootImage, and Greenfoot)
import java.awt.Color;
import java.awt.Font;
import java.util.Calendar;

/**
 * The ScoreBoard is used to display results on the screen. It can display some
 * text and several numbers.
 * 
 * @author M Kolling
 * @version 1.0
 */
public class ScoreBoard extends Actor
{
    public static final float FONT_SIZE = 48.0f;
    public static final int WIDTH = 400;
    public static final int HEIGHT = 300;
    
    /**
     * Create a score board with dummy result for testing.
     */
    public ScoreBoard()
    {
        this(1, 100);
    }

    /**
     * Create a score board for the final result.
     */
    public ScoreBoard(int level, int score)
    {
        makeImage("Game Over", "Level: ", level, "Score: ", score);
    }

    /**
     * Make the score board image.
     */
    private void makeImage(String title, String prefixLevel, int level, String prefixScore, int score)
    {
        GreenfootImage image = new GreenfootImage(WIDTH, HEIGHT);

        image.setColor(new Color(0,100,255, 128));
        image.fillRect(0, 0, WIDTH, HEIGHT);
        image.setColor(new Color(0, 0, 0, 128));
        image.fillRect(5, 5, WIDTH-10, HEIGHT-10);
        Font font = image.getFont();
        font = font.deriveFont(FONT_SIZE);
        image.setFont(font);
        image.setColor(Color.ORANGE);
        image.drawString(title, 60, 100);
        image.drawString(prefixLevel + level, 60, 175);
        image.drawString(prefixScore + score, 60, 225);
        setImage(image);
    }
}
